/**shmem.c*/
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "shmem.h"

uint8_t *mlinux_shm_base_w;
uint8_t *mlinux_shm_base_r;
int linux_write_len, linux_read_len;

/* CRC-16 表 */
const static unsigned short Lookup_crc_16[256] = {
	0x0000, 0xC0C1, 0xC181, 0x0140, 0xC301, 0x03C0, 0x0280, 0xC241,
	0xC601, 0x06C0, 0x0780, 0xC741, 0x0500, 0xC5C1, 0xC481, 0x0440,
	0xCC01, 0x0CC0, 0x0D80, 0xCD41, 0x0F00, 0xCFC1, 0xCE81, 0x0E40,
	0x0A00, 0xCAC1, 0xCB81, 0x0B40, 0xC901, 0x09C0, 0x0880, 0xC841,
	0xD801, 0x18C0, 0x1980, 0xD941, 0x1B00, 0xDBC1, 0xDA81, 0x1A40,
	0x1E00, 0xDEC1, 0xDF81, 0x1F40, 0xDD01, 0x1DC0, 0x1C80, 0xDC41,
	0x1400, 0xD4C1, 0xD581, 0x1540, 0xD701, 0x17C0, 0x1680, 0xD641,
	0xD201, 0x12C0, 0x1380, 0xD341, 0x1100, 0xD1C1, 0xD081, 0x1040,
	0xF001, 0x30C0, 0x3180, 0xF141, 0x3300, 0xF3C1, 0xF281, 0x3240,
	0x3600, 0xF6C1, 0xF781, 0x3740, 0xF501, 0x35C0, 0x3480, 0xF441,
	0x3C00, 0xFCC1, 0xFD81, 0x3D40, 0xFF01, 0x3FC0, 0x3E80, 0xFE41,
	0xFA01, 0x3AC0, 0x3B80, 0xFB41, 0x3900, 0xF9C1, 0xF881, 0x3840,
	0x2800, 0xE8C1, 0xE981, 0x2940, 0xEB01, 0x2BC0, 0x2A80, 0xEA41,
	0xEE01, 0x2EC0, 0x2F80, 0xEF41, 0x2D00, 0xEDC1, 0xEC81, 0x2C40,
	0xE401, 0x24C0, 0x2580, 0xE541, 0x2700, 0xE7C1, 0xE681, 0x2640,
	0x2200, 0xE2C1, 0xE381, 0x2340, 0xE101, 0x21C0, 0x2080, 0xE041,
	0xA001, 0x60C0, 0x6180, 0xA141, 0x6300, 0xA3C1, 0xA281, 0x6240,
	0x6600, 0xA6C1, 0xA781, 0x6740, 0xA501, 0x65C0, 0x6480, 0xA441,
	0x6C00, 0xACC1, 0xAD81, 0x6D40, 0xAF01, 0x6FC0, 0x6E80, 0xAE41,
	0xAA01, 0x6AC0, 0x6B80, 0xAB41, 0x6900, 0xA9C1, 0xA881, 0x6840,
	0x7800, 0xB8C1, 0xB981, 0x7940, 0xBB01, 0x7BC0, 0x7A80, 0xBA41,
	0xBE01, 0x7EC0, 0x7F80, 0xBF41, 0x7D00, 0xBDC1, 0xBC81, 0x7C40,
	0xB401, 0x74C0, 0x7580, 0xB541, 0x7700, 0xB7C1, 0xB681, 0x7640,
	0x7200, 0xB2C1, 0xB381, 0x7340, 0xB101, 0x71C0, 0x7080, 0xB041,
	0x5000, 0x90C1, 0x9181, 0x5140, 0x9301, 0x53C0, 0x5280, 0x9241,
	0x9601, 0x56C0, 0x5780, 0x9741, 0x5500, 0x95C1, 0x9481, 0x5440,
	0x9C01, 0x5CC0, 0x5D80, 0x9D41, 0x5F00, 0x9FC1, 0x9E81, 0x5E40,
	0x5A00, 0x9AC1, 0x9B81, 0x5B40, 0x9901, 0x59C0, 0x5880, 0x9841,
	0x8801, 0x48C0, 0x4980, 0x8941, 0x4B00, 0x8BC1, 0x8A81, 0x4A40,
	0x4E00, 0x8EC1, 0x8F81, 0x4F40, 0x8D01, 0x4DC0, 0x4C80, 0x8C41,
	0x4400, 0x84C1, 0x8581, 0x4540, 0x8701, 0x47C0, 0x4680, 0x8641,
	0x8201, 0x42C0, 0x4380, 0x8341, 0x4100, 0x81C1, 0x8081, 0x4040};

static unsigned short crc16(unsigned char *p, int len)
{
	unsigned short crc = 0;
	int zero = 1;

	if (len <= 0)
		return crc;

	while (len-- > 0)
	{
		if (*p != 0)
			zero = 0;
		crc = Lookup_crc_16[(crc & 0xff) ^ (*p++)] ^ (crc >> 8);
	}

	if (zero)
		crc = 0x5678; /* 若全为0，crc返回就不要为零 */
	return crc;
}


int shm_write_data(uint32_t _ul_addr, uint8_t *_puc_data, uint32_t _ul_len)
{
	int i = 0;

	if (mlinux_shm_base_w == NULL)
		return -1;

	if (_puc_data == NULL)
		return -1;
	if (_ul_len == 0)
		return -1;

	for (i = 0; i < _ul_len; i++)
	{
		if ((_ul_addr + i) >= linux_write_len)
			return -1;

		mlinux_shm_base_w[_ul_addr + i] = _puc_data[i];
	}

	return i;
}

int shm_packet_write_v2(uint32_t _ul_addr, uint8_t *_puc_data, uint32_t _ul_len)
{
	uint16_t us_updata = 0, us_data_a = 0, us_crc = 0;
	int ret = 0;

	if (_puc_data == NULL || _ul_len == 0)
		return -1;

	memcpy(&us_data_a, &mlinux_shm_base_w[_ul_addr + 2], 2);
	us_data_a++;
	memcpy(&mlinux_shm_base_w[_ul_addr + 2], &us_data_a, 2);

	/* 写数据区 */
	ret = shm_write_data(_ul_addr + 6, _puc_data + 6, _ul_len - 8);
	if (ret == -1)
		return -2;

	/* crc */
	us_crc = crc16(_puc_data + 6, _ul_len - 8);
	memcpy(&mlinux_shm_base_w[_ul_addr + _ul_len - 2], &us_crc, 2);
	// printf("cal us_crc = %04x\n", us_crc);

#if (1)
	// for (int i = 0; i < _ul_len + 6; i++)
	// {
	//     printf("data[%d]=%04x, ", i, *(_puc_data + i+ 6));
	// }
	for (int i = 0; i < _ul_len; i++)
	{
		printf("wbuf[%d]=0x%02x, ", i, *(mlinux_shm_base_w + _ul_addr + i));
	}
	printf("\n");
#endif

	memcpy(&mlinux_shm_base_w[_ul_addr + 4], &us_data_a, 2); // us_data_a和us_data_b保证一样
	us_updata = 1;
	memcpy(&mlinux_shm_base_w[_ul_addr], &us_updata, 2); // 数据更新

	for (int i = 0; i < _ul_len; i++) // zhl add TODO
		((uint8_t *)_puc_data)[i] = *(mlinux_shm_base_w + _ul_addr + i);

	/* 加上us_data_a, us_data_b, crc的长度 */
	return ret + 6;
}

/**
 * @brief          读取共享内存的数据
 * @version        1.0
 * @param[in/out]  {uint32_t} _ul_addr 读取共享内存的地址
 * @param[in/out]  {uint32_t} _ul_len 需要读取的数据长度
 * @param[in/out]  {uint8_t *} _puc_data_out 输出buf
 * @param[in/out]  {uint32_t} _uc_data_out_size 输出buf的长度
 * @return         int
 * @retval         成功返回读取数据的长度, 失败返回-1
 *
 * @warning        none
 * @note           none
 */
int shm_read_data(uint32_t _ul_addr, uint32_t _ul_len, uint8_t *_puc_data_out, uint32_t _uc_data_out_size)
{
	int i = 0;
	if (mlinux_shm_base_r == NULL)
		return -1;

	if (_puc_data_out == NULL)
		return -2;

	if ((_ul_len == 0) || (_uc_data_out_size == 0))
		return -3;

	for (i = 0; i < _ul_len; i++)
	{
		if ((_ul_addr + i) >= linux_read_len)
			return -4;

		if (i >= _uc_data_out_size)
			return -5;

		_puc_data_out[i] = mlinux_shm_base_r[_ul_addr + i];
	}

	return i;
}

/**
 * @brief          读取共享内存的数据(自动处理us_data_a, us_data_b, crc).
 * @version        1.0
 * @param[in/out]  {uint32_t} _ul_addr 读取共享内存的地址
 * @param[in/out]  {uint32_t} _ul_len 需要读取数据的长度
 * @param[in/out]  {uint8_t *} _puc_data_out 输出buf
 * @param[in/out]  {uint32_t} _uc_data_out_size 输出buf的长度
 * @return         * int
 * @retval         成功返回读取数据的长度 失败返回 < 0
 *
 * @warning        none
 * @note           输入参数data为带有us_data_a, us_data_b和crc的结构体，len为整个结构体的长度
 * @note           应用层不需要理会us_data_a, us_data_b和crc
 */
int shm_packet_read_v2(uint32_t _ul_addr, uint32_t _ul_len, uint8_t *_puc_data_out, uint32_t _uc_data_out_size)
{
	uint16_t us_updata = 0, us_data_a = 0, us_data_b = 0;
	uint16_t us_crc = 0, read_crc = 0;
	int ret = 0;
	ret = shm_read_data(_ul_addr, _ul_len, _puc_data_out, _uc_data_out_size);
	
#if (0)
	// for (int i = 0; i < _ul_len + 6; i++)
	// {
	//     printf("data[%d]=%04x, ", i, *(_puc_data + i+ 6));
	// }
	// printf("(mlinux_shm_base_r +_ul_addr:%X)->p: 0x%llX\n", _ul_addr, mlinux_shm_base_r + _ul_addr);
	for (int i = 0; i < _ul_len; i++)
	{
		printf("rbuf[%d]=0x%02x, ", i, *(mlinux_shm_base_r + _ul_addr + i));
	}
	printf("\n\n");
#endif

	/* 没有数据更新 */
	us_updata = _puc_data_out[0] + ((uint16_t)_puc_data_out[1] << 8);
	if (0 == us_updata)
		return -1;

	us_data_a = _puc_data_out[2] + ((uint16_t)_puc_data_out[3] << 8);
	us_data_b = _puc_data_out[4] + ((uint16_t)_puc_data_out[5] << 8);

	/* 是否有在进行读写 */ //TODO 暂时注释
	if ((us_data_a == us_data_b))
	{
		/* 在拷贝过程中，数据没有被修改 */
		us_crc = crc16(_puc_data_out + 6, _ul_len - 8);
		read_crc = _puc_data_out[_ul_len - 2] + ((uint16_t)_puc_data_out[_ul_len - 1] << 8);
		// printf("cal us_crc = %04x, read us_crc = %04x\n", us_crc, read_crc);
		if (us_crc != read_crc)
		{
			return -2;
		}
	}
	else
	{
		return -3;
	}

	us_updata = 0;
	memcpy(&mlinux_shm_base_r[_ul_addr], &us_updata, 2); // 数据读取完成

	return ret;
}

#define ARV_SHMEM_REGION_LEN 0x10
int share_mem_init_v2(struct shmem_fd *shmem_fd)
{
	int fd;
	void *shmem;
	int ret;

	fd = open("/dev/arv-shmem", O_RDWR);
	if (fd == -1)
	{
		printf("can not open file /dev/arv-shmem\n");
		return -1;
	}

	ret = ioctl(fd, ARV_SHMEM_REGION_LEN, &shmem_fd->shmem_len);
	if (ret)
	{
		printf("failed to get the len of shmem\n");
		return -1;
	}
	printf("shmem len: 0x%x\n", shmem_fd->shmem_len);

	shmem_fd->linux_write_len = max_shmem_wr_len(shmem_fd->shmem_len);
	shmem_fd->linux_read_len = max_shmem_rd_len(shmem_fd->shmem_len);

	shmem = mmap(NULL, shmem_fd->shmem_len, PROT_READ | PROT_WRITE,
				 MAP_SHARED, fd, 0);
	if (shmem <= 0)
	{
		printf("failed to get shmem\n");
		return -1;
	}
	printf("mmap: 0x%llx\n", (unsigned long long)shmem);

	shmem_fd->fd = fd;
	shmem_fd->linux_write = (uint8_t *)shmem;
	shmem_fd->linux_read = (uint8_t *)(shmem + shmem_fd->linux_write_len);
	printf("shmem_fd->linux_write->p: 0x%llX, linux_write_len: %d\n", shmem_fd->linux_write, shmem_fd->linux_write_len);
	printf("shmem_fd->linux_read->p: 0x%llX, linux_read_len: %d\n", shmem_fd->linux_read, shmem_fd->linux_read_len);

	mlinux_shm_base_w = (uint8_t *)(shmem_fd->linux_write); // 共享内存---写(向R核写入数据)---开始地址
	mlinux_shm_base_r = (uint8_t *)(shmem_fd->linux_read); // 共享内存---读(从R核读取数据)---开始地址
	linux_write_len = shmem_fd->linux_write_len;
	linux_read_len = shmem_fd->linux_read_len;

	return 0;
}

void share_mem_exit_v2(struct shmem_fd *shmem_fd)
{
	munmap(shmem_fd->linux_write, shmem_fd->shmem_len);
	close(shmem_fd->fd);
}
